-- Copyright (c) 2008-2014 Algo Communication Products Ltd.
-- parse and save configuratioin file

local conf_file = "/opt/algo/config/user.conf"
local default_conf = '/opt/algo/info/default.conf'
local device_file = "/opt/algo/info/device.conf"
local params = {}
local device_info = {}

function conf_load()
	local file, err
	local line, k, v

	file, err = io.open(default_conf, "r")
	if err then return end
	while true do
		line = file:read()
		if line == nil then break end

		k, v = line:gmatch("([%l%d%._]+) = (.*)")()
		if(k ~= nil and v ~= nil) then
			params[k] = v
		end
	end
	file:close(file)

	file, err = io.open(conf_file, "r")
	if err then return end
	while true do
		line = file:read()
		if line == nil then break end

		k, v = line:gmatch("([%l%d%._]+) = (.*)")()
		if(k ~= nil and v ~= nil) then
			params[k] = v
		end
	end
	file:close(file)

	file, err = io.open(device_file, 'r')
	if err then return end
	while true do
		line = file:read()
		if line == nil then break end

		k, v = line:gmatch("([%l%d%._]+) = (.*)")()
		if(k ~= nil and v ~= nil) then
			device_info[k] = v
		end
	end
	file:close(file)
end

function conf_save()
	local keyind = {}
	for k,v in pairs(params) do
		table.insert(keyind, k)
	end
	table.sort(keyind)
	file, err = io.open(conf_file, "w")
	if err then return _, err end
	for i,v in ipairs(keyind) do
		file:write(string.format("%s = %s\n", v, params[v]))
	end
	file:close()
end

function conf_getp(name)
	if params[name] then
		return params[name]
	else
		return ''
	end
end

function conf_getpn(name)
	local str, num
	if params[name] then
		str = params[name]
	else
		return 0
	end
	num = tonumber(str)
	if num then return num else return 0 end
end

function conf_setp(name, value)
	params[name] = value
end

function conf_remove(name)
	params[name] = nil
end

function conf_getdevice(name)
	if device_info[name] then
		return device_info[name]
	else
		return ''
	end
end

function conf_update(name, settings, flags, service)
	if (conf_getp(name) ~= settings[name]) then
		params[name] = settings[name]
		flags[service] = 1
		flags['any'] = 1
	end
end
