-- Copyright (c) 2014-2016 Algo Communication Products Ltd.

require('webpage')
require('conf')

local menu_top = {
	{'Status', 'Basic Settings', 'Additional Features', 'Advanced Settings', 'System'},
	{'/index.lua', '/control/shsip.lua', '/control/shio.lua', '/control/network.lua',
	 '/control/maint.lua'}}

local menu_second = {
	['Status'] = {{'General'},
		{'/index.lua'}},
	['Basic Settings']= {{'SIP', 'Features', 'Multicast'},
		{'/control/shsip.lua', '/control/feature.lua',
		 '/control/shmcast.lua'}},
	['Additional Features'] = {{'Input/Output', 'More Page Extensions'},
		{'/control/shio.lua', '/control/shext.lua'}},
	['Advanced Settings'] = {{'Network', 'Admin', 'Time',
		 'Provisioning', 'Tones',
		 'Advanced Audio',
		 'Advanced SIP',
		 'Advanced Multicast'},
		{'/control/network.lua', '/control/admin.lua',
		 '/control/time.lua',
		 '/control/prov.lua',
		 '/control/toneman.lua',
		 '/control/shadvaud.lua',
		 '/control/sipadv.lua',
		 '/control/shadvmcast.lua'}},
	['System'] = {{'Maintenance', 'System Log', 'About'},
		{'/control/maint.lua', '/control/syslog.lua',
		 '/control/about.lua'}}
}

prod_cst_header = webpage_cst_header

function prod_cst_menu(top, second, pub)
	if pub then
		return ''
	else
		return webpage_cst_menu(menu_top, menu_second, top, second)
	end
end

function prod_cst_welcometitle()
	return webpage_cst_welcometitle(conf_getdevice('product.vendor'),
		conf_getdevice('product.name'),
		conf_getdevice('product.desc'))
end

function prod_cst_welcome()
	local welcome
	local welcome_flag = conf_getpn('admin.welcome')
	if welcome_flag == 1 then
		welcome = webpage_cst_welcome(conf_getdevice('product.vendor'),
			conf_getdevice('product.name'),
			conf_getdevice('product.desc'), 1)
	else
		welcome = ''
	end
	return welcome
end

function prod_cst_status()
	local sip_status = webpage_read_file('/var/run/reg.status',
		'Not Registered')
	local call_status = webpage_read_file('/var/run/call.status', 'Idle')
	local ssr_status = webpage_read_file('/var/run/ssr.status', 'N/A')
	local prov_status = webpage_read_file('/var/run/prov.status', 'N/A')
	local mcast_status = webpage_read_file('/var/run/mcast.status', 'N/A')
	local mcast_slave_status = webpage_read_file('/var/run/slave.status', 'N/A')
	local relayin_status = webpage_read_file('/var/run/relayin.status', 'N/A')
	local timezone = webpage_read_file('/etc/timezone', 'N/A')
	local mac, ip, netmask = webpage_get_network()

	return webpage_cst_status('Device Name', conf_getp('admin.devname')) ..
		webpage_cst_status('SIP Registration', sip_status) ..
		webpage_cst_status('Call Status', call_status) ..
		webpage_cst_status('Multicast Mode', mcast_status) ..
		webpage_cst_status('Relay Input Status', relayin_status) ..
		webpage_cst_status('Proxy Status', ssr_status) ..
		webpage_cst_status('Provisioning Status', prov_status) ..
		webpage_cst_status('MAC', mac) ..
		webpage_cst_status('IP', ip) ..
		webpage_cst_status('Netmask', netmask) ..
		webpage_cst_status('Date/Time', os.date()) ..
		webpage_cst_status('Timezone', timezone)
end

function prod_cst_info()
	local info = ''
end

function prod_cst_tonelist(name, extra)
	local allfiles = {}
	local path = '/opt/algo/web/tones'
	for file in lfs.dir(path) do
		if file ~= '.' and file ~= '..' then
			table.insert(allfiles, file)
		end
	end
	table.sort(allfiles)

	if extra then
		local allval = {}
		for i,v in ipairs(allfiles) do
			allval[i] = v
		end
		for k,v in pairs(extra) do
			table.insert(allfiles, 1, k)
			table.insert(allval, 1, v)
		end
		return webpage_cst_select(name, allval, allfiles)
	else
		return webpage_cst_select(name, allfiles, allfiles)
	end
end

prod_default_pwd = 'algo'
prod_footer = webpage_footer

prod_company_info = webpage_cst_algoinfo()

prod_credit_info = ''

function prod_cst_prodinfo(pub)
	return webpage_cst_prodinfo(conf_getdevice('product.vendor') .. ' ' ..
		conf_getdevice('product.name') .. ' ' ..
		conf_getdevice('product.desc'), nil, nil, nil, pub)
end

prod_startpage = '/control/shsip.lua'
