-- Copyright (c) 2013-2015 Algo Communication Products Ltd.

require('session')
require('webpage')
require('conf')
require('prod')

conf_load()
local auth_failed = session_load()
if auth_failed == 1 then
	session_reset()
	return
else
	session_start_page()
end

local flags = {['any'] = 0, ['reboot'] = 0}

local cl = mg.request_info.http_headers['Content-Length']
if cl then
	local settings = {}

	webpage_parse_post(cl, settings)
	conf_update('net.dhcp.use', settings, flags, 'reboot')
	conf_update('net.ip', settings, flags, 'reboot')
	conf_update('net.mask', settings, flags, 'reboot')
	conf_update('net.gateway', settings, flags, 'reboot')
	conf_update('net.dns1', settings, flags, 'reboot')
	conf_update('net.dns2', settings, flags, 'reboot')

	conf_update('net.vlan.use', settings, flags, 'reboot')
	conf_update('net.vlan.id', settings, flags, 'reboot')
	conf_update('net.vlan.priority', settings, flags, 'reboot')

	conf_update('net.dscp.sip', settings, flags, 'reboot')
	conf_update('net.dscp.rtp', settings, flags, 'reboot')
--	conf_update('net.dscp.rtcp', settings, flags, 'reboot')

	if flags['any'] == 1 then
		conf_save()
	end
	if flags['reboot'] == 1 then
		g_reboot = 1
		session_save()
	end
end
session_save()

local form_start = webpage_cst_formstart('/control/network.lua')

local page_start = webpage_cst_pagestart('Network Settings')

secthd_net = webpage_cst_secthd('Network Interface')

local js_dhcp = [[
<script type="text/javascript">
function display_ip_options(mode) {
	var display = (mode == 0) ? 'none' : 'block';
	document.getElementById("net_ip").style.display = display;
	document.getElementById("net_mask").style.display = display;
	document.getElementById("net_gateway").style.display = display;
	document.getElementById("net_dns1").style.display = display;
	document.getElementById("net_dns2").style.display = display;
	var display = (mode == 1) ? 'none' : 'block';
	document.getElementById("dhcp_timeout").style.display = display;
}
</script>]]

local dhcp_js0 = [[display_ip_options(1);]]
local dhcp_js1 = [[display_ip_options(0);]]
local hide = conf_getpn('net.dhcp.use')
local p_protocol = webpage_cst_param('Protocol',
	webpage_cst_radio('net.dhcp.use', {'Static IP', 'DHCP'}, nil,
		{dhcp_js0, dhcp_js1}),
	nil, nil, 0)
local p_ip = webpage_cst_param('IP Address',
	webpage_cst_text('net.ip'), nil, 'net_ip', hide)
local p_netmask = webpage_cst_param('Netmask',
	webpage_cst_text('net.mask'), nil, 'net_mask', hide)
local p_gateway = webpage_cst_param('Gateway',
	webpage_cst_text('net.gateway'), nil, 'net_gateway', hide)
local p_dns1 = webpage_cst_param('DNS Server 1',
	webpage_cst_text('net.dns1'), nil, 'net_dns1', hide)
local p_dns2 = webpage_cst_param('DNS Server 2',
	webpage_cst_text('net.dns2'), nil, 'net_dns2', hide)

secthd_vlan = webpage_cst_secthd('802.1Q Virtual LAN')

local js_vlan = [[
<script type="text/javascript">
function display_vlan_options(mode) {
	var display = (mode == 0) ? 'none' : 'block';
	document.getElementById("vlan_id").style.display = display;
	document.getElementById("vlan_priority").style.display = display;
}
</script>]]

local vlan_js0 = [[display_vlan_options(1);]]
local vlan_js1 = [[display_vlan_options(0);]]
local hide = 1 - conf_getpn('net.vlan.use')
local p_vlan_use = webpage_cst_param('VLAN Mode',
	webpage_cst_enabled('net.vlan.use', {vlan_js0, vlan_js1}))
local p_vlan_id = webpage_cst_param('VLAN ID',
	webpage_cst_text('net.vlan.id'), 'Value range: 0 to 4094',
	'vlan_id', hide)
local p_vlan_priority = webpage_cst_param('VLAN Priority',
	webpage_cst_text('net.vlan.priority'), 'Value range: 0 to 7',
	'vlan_priority', hide)

local secthd_dscp = webpage_cst_secthd('Differentiated Services')
local p_dscp_sip = webpage_cst_param('SIP (6-bit <abbr title="Differentiated Services Code Point">DSCP</abbr> value)',
	webpage_cst_text('net.dscp.sip'))
local p_dscp_rtp = webpage_cst_param('RTP (6-bit <abbr title="Differentiated Services Code Point">DSCP</abbr> value)',
	webpage_cst_text('net.dscp.rtp'))
--[[
local p_dscp_rtcp = webpage_cst_param('RTCP (6-bit <abbr title="Differentiated Services Code Point">DSCP</abbr> value)',
	webpage_cst_text('net.dscp.rtcp'))
]]

mg.write(prod_cst_header() ..
	prod_cst_menu('Advanced Settings', 'Network') ..
	webpage_cst_mchd(flags['any'], flags['reboot']) ..
	form_start .. page_start ..
	secthd_net .. webpage_subsect_hd .. js_dhcp ..
	p_protocol .. p_ip .. p_netmask .. p_gateway .. p_dns1 .. p_dns2 ..
	webpage_subsect_ft .. webpage_sect_ft ..
	secthd_vlan .. webpage_subsect_hd .. js_vlan ..
	p_vlan_use .. p_vlan_id .. p_vlan_priority ..
	webpage_subsect_ft .. webpage_sect_ft ..
	secthd_dscp .. webpage_subsect_hd ..
	p_dscp_sip .. p_dscp_rtp ..
	webpage_subsect_ft .. webpage_sect_ft ..
	webpage_page_end .. webpage_form_end_save ..
	webpage_mc_ft ..
	prod_footer)
