-- Copyright (c) 2015 Algo Communication Products Ltd.

require('session')
require('webpage')
require('conf')
require('prod')

conf_load()
local auth_failed = session_load()
if auth_failed == 1 then
	session_reset()
	return
else
	session_start_page()
end

local nzones = 50
local flags = {['any'] = 0, ['main'] = 0}

local cl = mg.request_info.http_headers['Content-Length']
if cl then
	local settings = {}

	webpage_parse_post(cl, settings)

--	if conf_getdevice('product.name') == '8301' then
--		conf_update('audio.dtmf.use', settings, flags, 'main')
--	end

	for i=1,nzones do
		conf_update('mcast.useext' .. i, settings, flags, 'main')
		conf_update('mcast.ext' .. i, settings, flags, 'main')
		conf_update('mcast.auth' .. i, settings, flags, 'main')
		conf_update('mcast.pwd' .. i, settings, flags, 'main')
	end

	if flags['any'] == 1 then
		conf_save()
	end
	if flags['main'] == 1 then
		os.execute('/etc/init.d/algo-main restart')
	end
end
session_save()

local form_start = webpage_cst_formstart('/control/shext.lua')

local page_start = webpage_cst_pagestart('More Page Extensions')

local basic_secthd = webpage_cst_secthd('Basic Extensions')

local exp_mode = conf_getpn('mcast.zones.exp')
local exp_secthd = webpage_cst_secthd('Expanded Extensions', 'exp_exts', 1 - exp_mode)

local js_opts = [[<script type="text/javascript">
function display_opts(zone)
{
	var length;
	var page_enabled = 0;
	var radios = document.getElementsByName('mcast.useext' + zone);
	for (var i = 0, length = radios.length; i < length; i++) {
		if (radios[i].checked) {
			page_enabled = parseInt(radios[i].value);
			break;
		}
	}

	var display = (page_enabled == 0) ? 'none' : 'block';
	document.getElementById("ext"+ zone).style.display = display;
	document.getElementById("auth"+ zone).style.display = display;
	document.getElementById("pwd"+ zone).style.display = display;
}
</script>]]

local display_js = 'display_opts(%s);'
local p_page_opts = {}
local display_opts = '' 

local i = 9
display_opts = string.format(display_js, i)

p_page_opts[i] = webpage_cst_param('Priority Call Page Extension',
	webpage_cst_enabled('mcast.useext'..i, {display_opts, display_opts}), nil) ..
	webpage_cst_param('Extension',
		webpage_cst_text('mcast.ext'..i), nil, 'ext'..i, 0) ..
	webpage_cst_param('Authentication ID',
		webpage_cst_text('mcast.auth'..i), nil, 'auth'..i, 0) ..
	webpage_cst_pwd('Authentication Password', 'mcast.pwd' .. i, 'pwd' .. i, 0)

i = 8
display_opts = string.format(display_js, i)
p_page_opts[i] = webpage_cst_param('All Call Page Extension',
	webpage_cst_enabled('mcast.useext' .. i, {display_opts, display_opts}), nil) ..
	webpage_cst_param('Extension',
		webpage_cst_text('mcast.ext' .. i), nil, 'ext'..i, 0) ..
	webpage_cst_param('Authentication ID',
		webpage_cst_text('mcast.auth' .. i), nil, 'auth'..i, 0) ..
	webpage_cst_pwd('Authentication Password', 'mcast.pwd' .. i, 'pwd' .. i, 0)

i = 7
display_opts = string.format(display_js, i)
p_page_opts[i] = webpage_cst_param('Music Page Extension',
	webpage_cst_enabled('mcast.useext' .. i, {display_opts, display_opts}), nil) ..
	webpage_cst_param('Extension',
		webpage_cst_text('mcast.ext' .. i), nil, 'ext'..i, 0) ..
	webpage_cst_param('Authentication ID',
		webpage_cst_text('mcast.auth' .. i), nil, 'auth'..i, 0) ..
	webpage_cst_pwd('Authentication Password', 'mcast.pwd' .. i, 'pwd' .. i, 0)

for i=1,nzones do
	if i >= 7 and i <= 9 then
		-- Do nothing	
	else
		display_opts = string.format(display_js, i)
		p_page_opts[i] = webpage_cst_param('Zone ' .. i .. ' Page Extension',
			webpage_cst_enabled('mcast.useext' .. i,
				{display_opts, display_opts}), nil) ..
			webpage_cst_param('Extension',
				webpage_cst_text('mcast.ext' .. i), nil, 'ext'..i, 0) ..
			webpage_cst_param('Authentication ID',
				webpage_cst_text('mcast.auth' .. i), nil, 'auth'..i, 0) ..
			webpage_cst_pwd('Authentication Password', 'mcast.pwd' .. i, 'pwd' .. i, 0)
	end 
end

local p_basic_exts = ''
local p_exp_exts = ''

	p_basic_exts =  webpage_subsect_hd .. p_page_opts[9] .. webpage_subsect_ft ..
		webpage_subsect_hd .. p_page_opts[8] .. webpage_subsect_ft

for i=1,7 do
	p_basic_exts = p_basic_exts .. webpage_subsect_hd .. 
		p_page_opts[i] .. webpage_subsect_ft
end

for i=10,nzones do
	p_exp_exts = p_exp_exts .. webpage_subsect_hd ..
		p_page_opts[i] .. webpage_subsect_ft
end

local js_hide = [[<script type="text/javascript">
function hide_opts()
{
	var length;
	var radios;
	var display;
	var page_enabled = 0;
	for (var zone = 0; zone <= 50; zone++) {
		radios = document.getElementsByName('mcast.useext' + zone);
		for (var i = 0, length = radios.length; i < length; i++) {
			if (radios[i].checked) {
				page_enabled = parseInt(radios[i].value);
				display = (page_enabled == 0) ? 'none' : 'block';
				document.getElementById("ext"+ zone).style.display = display;
				document.getElementById("auth"+ zone).style.display = display;
				document.getElementById("pwd"+ zone).style.display = display;
				break;
			}
		}
	}
}

window.onload = hide_opts;
</script>]]
mg.write(prod_cst_header() ..
	prod_cst_menu('Additional Features', 'More Page Extensions') ..
	webpage_cst_mchd(flags['any'], 0) ..
	form_start .. page_start ..
	basic_secthd .. js_opts ..
	p_basic_exts ..
	webpage_sect_ft ..
	exp_secthd ..
	p_exp_exts ..
	webpage_sect_ft ..
	js_hide ..
	webpage_page_end .. webpage_form_end_save ..
	webpage_mc_ft ..
	prod_footer)
