-- Copyright (c) 2013-2015 Algo Communication Products Ltd.

require('session')
require('webpage')
require('conf')
require('prod')

conf_load()
local auth_failed = session_load()
if auth_failed == 1 then
	session_reset()
	return
else
	session_start_page()
end

local vars = {}
local sect_view = ''
local p_view = ''

local page_start = webpage_cst_pagestart('System Log')

local secthd_download = webpage_cst_secthd('Download Log Files')

local js_log = [[window.location.href='/control/syslog.txt']]
local p_file = webpage_cst_param('Log File',
	webpage_cst_button('log', 'Download syslog.txt', 'download', js_log, 1))

local cl = mg.request_info.http_headers['Content-Length']
if cl then
	webpage_parse_multipart(cl, vars)

	if vars['view'] then
		local secthd_text = webpage_cst_secthd('Log Text')
		local log_start = [[<textarea readonly="readonly" wrap="on" id="syslog">]]
		local log_end = [[</textarea>]]

		mg.write(prod_cst_header() ..
			prod_cst_menu('System', 'System Log') ..
			webpage_cst_mchd(0, 0) .. page_start ..
			secthd_download .. webpage_subsect_hd ..
			p_file ..
			webpage_subsect_ft .. webpage_sect_ft ..
			secthd_text .. webpage_subsect_hd ..
			log_start)

		session_send_file('/var/log/syslog.1')
		session_send_file('/var/log/syslog')

		mg.write(log_end ..
			webpage_subsect_ft .. webpage_sect_ft ..
			webpage_page_end .. webpage_mc_ft .. prod_footer)
	end
else
	p_view = webpage_cst_param('',
		webpage_cst_formstart('/control/syslog.lua') ..
		webpage_cst_button('view', 'View', 'play') ..
		webpage_form_end)
	mg.write(prod_cst_header() ..
		prod_cst_menu('System', 'System Log') ..
		webpage_cst_mchd(0, 0) .. page_start ..
		secthd_download .. webpage_subsect_hd ..
		p_file .. p_view ..
		webpage_subsect_ft .. webpage_sect_ft ..
		webpage_page_end .. webpage_mc_ft ..
		prod_footer)
end
session_save()
