-- Copyright (c) 2015 Algo Communication Products Ltd.

require('session')
require("webpage")
require('conf')
require('prod')

conf_load()
local auth_failed = session_load()
if auth_failed == 1 then
	session_reset()
	return
else
	session_start_page()
end

local flags = {['any'] = 0, ['net'] = 0, ['io'] = 0}

local cl = mg.request_info.http_headers['Content-Length']
if cl then
	local settings = {}

	webpage_parse_post(cl, settings)
	conf_update('net.telnet', settings, flags, 'net')
	conf_update('net.ssh', settings, flags, 'net')

	conf_update('io.relays', settings, flags, 'io')

	if flags['net'] == 1 then
		if settings['net.telnet'] == '0' then
			conf_remove('net.telnet')
		end
		if settings['net.ssh'] == '0' then
			conf_remove('net.ssh')
		end
		conf_save()
		os.execute('/opt/algo/bin/apply-settings netadmin')
	end

	if flags['io'] == 1 then
		conf_save()
		os.execute('/etc/init.d/algo-main restart')
	end
end
session_save()

local form_start = webpage_cst_formstart('/control/tool.lua')

local page_start = webpage_cst_pagestart('Tools')

local secthd_gen = webpage_cst_secthd('General')

local p_telnet = webpage_cst_param('Telnet Service',
	webpage_cst_enabled('net.telnet'))
local p_ssh = webpage_cst_param('SSH Service',
	webpage_cst_enabled('net.ssh'))

local relayctrl

if conf_getdevice('product.name') == '8373' then
	local secthd_relay = webpage_cst_secthd('Outputs')
	local p_relays = webpage_cst_param('Relays',
		webpage_cst_radio('io.relays', {'Test Mode (Active at startup)', 'Normal'}, {'1', '0'}))

	relayctrl = secthd_relay .. webpage_subsect_hd ..
		p_relays ..
		webpage_subsect_ft .. webpage_sect_ft
else
	relayctrl = ''
end

mg.write(prod_cst_header() ..
	prod_cst_menu('Advanced Settings', 'Tool') ..
	webpage_cst_mchd(flags['net'], 0) ..
	form_start .. page_start ..
	secthd_gen .. webpage_subsect_hd ..
	p_telnet .. p_ssh ..
	webpage_subsect_ft .. webpage_sect_ft ..
	relayctrl ..
	webpage_page_end .. webpage_form_end_save ..
	webpage_mc_ft ..
	prod_footer)
