-- Copyright (c) 2013-2016 Algo Communication Products Ltd.

require('session')
require('webpage')
require('conf')
require('prod')

conf_load()

local auth_failed = session_load()

local cl = mg.request_info.http_headers['Content-Length']
if cl then
	local settings = {}
	webpage_parse_post(cl, settings)

	if settings['pwd'] == conf_getp('admin.pwd') then
		session_generate()
		return
	else
		auth_failed = 2
	end
end

session_start_page()

local js_all = [[
<script type="text/javascript">
var cookie_name="testcookie=1";
var cookie_disabled = true;
function set_cookie()
{
	document.cookie=cookie_name;
}
function check_cookie()
{
	return (document.cookie.indexOf(cookie_name)!=-1)? true : false;
}
function delete_cookie()
{
	var cookie_date = new Date();
	cookie_date.setTime(cookie_date.getTime() - 1 );
	document.cookie = cookie_name += "; expires=" + cookie_date.toGMTString();
}

set_cookie();
if(check_cookie()) {
	cookie_disabled = false;
	delete_cookie();
}
if(cookie_disabled) {
	document.write('<div class="errorbox"><strong>Cookie Required</strong><br />Please enabled HTTP Cookie capacity in your browser.</div>');
}

// update status automatically
function refresh_status()
{
	if(window_has_focus == false) return;
	xmlhttp.open("GET", "/ajax_status.lua", true);
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4) {
			if (xmlhttp.status==200) {
				document.getElementById("status").innerHTML =
					xmlhttp.responseText;;
			}
		}
	}
	xmlhttp.send(null);
}

function refresh_timely()
{
	refresh_status();
	setInterval("refresh_status()", 1000);
}

refresh_timely();
</script>
]]

local secthd_login = webpage_cst_secthd('Login')

local login_pwd = [[
<input type="password" class="cbi-input-text" name="pwd" value="" />]]
local login_button = [[
<input type="submit" value="Login" class="cbi-button cbi-button-login">]]

local warning = nil
if prod_cst_info then
	warning = prod_cst_info()
end
local sect_body_login = webpage_cst_formstart('/index.lua') ..
	webpage_cst_param('Password  (default:<b> ' ..
		prod_default_pwd .. '</b>)',
		login_pwd .. login_button , warning, nil, 0, '/static/exclamation.png') ..
	webpage_form_end

local status_subsect_hd = '<fieldset class="cbi-section-node" id="status">'

if auth_failed == 0 then
	session_save()
	mg.write(prod_cst_header() ..
		prod_cst_menu('Status', 'General') ..
		webpage_cst_mchd(0, 0, nil, js_all) ..
		prod_cst_welcometitle() .. prod_cst_welcome() ..
		webpage_cst_secthd('Status') .. status_subsect_hd ..
		prod_cst_status() ..
		webpage_subsect_ft .. webpage_sect_ft ..
		webpage_mc_ft ..
		prod_footer)
else
	local pwdmsg
	if auth_failed == 2 then
		pwdmsg = {['Invalid Password'] =
			'Please use the correct password.'}
	else
		pwdmsg = nil
	end
	mg.write(prod_cst_header(1) ..
		prod_cst_menu('Status', 'General', 1) ..
		webpage_cst_mchd(0, 0, pwdmsg, js_all) ..
		prod_cst_welcometitle() .. prod_cst_welcome() ..
		webpage_cst_secthd('Login') .. webpage_subsect_hd ..
		sect_body_login ..
		webpage_subsect_ft .. webpage_sect_ft ..
		webpage_cst_secthd('Status') .. status_subsect_hd ..
		prod_cst_status() ..
		webpage_subsect_ft .. webpage_sect_ft ..
		webpage_mc_ft ..
		prod_footer)
end
